VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsINIControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetPrivateProfileString Lib "KERNEL32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "KERNEL32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Private m_strFileName As String
Private m_strSection As String
Private m_strKey As String
Private m_strCurrentValue As String

'Get/lets for reading the value from the section and Key specified
Public Property Get CurrentValue() As String
  m_strCurrentValue = ReadINIFileData()
  CurrentValue = m_strCurrentValue
End Property
Public Property Let CurrentValue(ByVal strValue As String)
  m_strCurrentValue = strValue
  Call WriteINIFileData
End Property

'Get/lets for the Key
Public Property Get Key() As String
  Key = m_strKey
End Property
Public Property Let Key(ByVal strKey As String)
  m_strKey = strKey
End Property

'Get/Set for the ini file name. Only set once
Public Property Get FileName() As String
  FileName = m_strFileName
End Property
Public Property Let FileName(ByVal strFileName As String)
  m_strFileName = strFileName
End Property

'Get/lets for the section needing to be read
Public Property Get Section() As String
  Section = m_strSection
End Property
Public Property Let Section(ByVal strSection As String)
  m_strSection = strSection
End Property

'*************************************************************************************************************
'* Description: Read an item from the INI file
'* Input:      None
'* Returns:    Boolean
'* Programmer: MBevan
'* Date:       04/Oct/2003
'*************************************************************************************************************
Public Function ReadINIFileData() As String
Dim n_strReturnValue As String
Dim n_strReturnBuffer As String * 75
Dim n_iBufferLength As Integer
Dim n_iValueLength As Integer
Dim n_strMessage As String

On Error GoTo EH_ReadINIFileData
n_strReturnValue = ""

n_iBufferLength = Len(n_strReturnBuffer)
n_iValueLength = GetPrivateProfileString(m_strSection, m_strKey, "", n_strReturnBuffer, n_iBufferLength, m_strFileName)
If n_iValueLength > 0 Then n_strReturnValue = Left$(n_strReturnBuffer, n_iValueLength)

NormalExit_ReadINIFileData:
    ReadINIFileData = n_strReturnValue
    On Error GoTo 0
    Exit Function

EH_ReadINIFileData:
    n_strMessage = "Failed to read INI file with error: " & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    Resume NormalExit_ReadINIFileData

End Function

'*************************************************************************************************************
'* Description: Write an item to the INI file
'* Input:      None
'* Returns:    Boolean
'* Programmer: MBevan
'* Date:       04/Oct/2003
'*************************************************************************************************************
Public Function WriteINIFileData() As Boolean
Dim n_bReturnValue As Boolean
Dim n_lLastReturnCode As Long
Dim n_strMessage As String

On Error GoTo EH_WriteINIFileData
n_bReturnValue = False

n_lLastReturnCode = WritePrivateProfileString(m_strSection, m_strKey, m_strCurrentValue, m_strFileName)
If n_lLastReturnCode = 0 Then 'non-zero value = success
    n_strMessage = "INI file data write failure"
    Call MsgBox(n_strMessage, vbOKOnly + vbExclamation, "System Message")
    GoTo NormalExit_WriteINIFileData
End If

n_bReturnValue = True

NormalExit_WriteINIFileData:
    WriteINIFileData = n_bReturnValue
    On Error GoTo 0
    Exit Function

EH_WriteINIFileData:
    n_strMessage = "Failed to write to INI file with error: " & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    Resume NormalExit_WriteINIFileData

End Function

